package at.fhj.airkoality.db.room;

import android.arch.persistence.room.Database;
import android.arch.persistence.room.Room;
import android.arch.persistence.room.RoomDatabase;
import android.arch.persistence.room.TypeConverters;
import android.content.Context;

import at.fhj.airkoality.model.LatestMeasurements;
import at.fhj.airkoality.model.Location;

@Database(entities = {Location.class, LatestMeasurements.class}, version = 1,exportSchema = false)
@TypeConverters({Converters.class})
public abstract class AirKoalityDB extends RoomDatabase {

    private static AirKoalityDB instance;

    public abstract LocationDAO locationDAO();




    public static AirKoalityDB getDatabase(Context context){
        if (instance == null) {
            instance = Room.databaseBuilder(context, AirKoalityDB.class, "airkoality").allowMainThreadQueries().build();
        }
           return instance;
    }


    public abstract LatestMeasurementsDAO latestMeasurementsDAO();
}
