package at.fhj.airkoality.db.room;

import android.arch.persistence.room.TypeConverter;

import java.util.ArrayList;

import at.fhj.airkoality.model.Measurement;

public class Converters {

    @TypeConverter
    public static ArrayList<Measurement> fromStringToMeasurements(String value) {
        ArrayList<Measurement> measurementsList = new ArrayList<>();
        String[] measurements = value.split("\\|");

        for (String s : measurements) {
            String[] parts = s.split(";");
            measurementsList.add(new Measurement(parts[0], Double.valueOf(parts[1]), parts[2]));
        }

        return measurementsList;
    }

    @TypeConverter
    public static String fromMeasurementsToString(ArrayList<Measurement> measurements) {
        String measurementsString = "";

        if(measurements != null) {
            for (int i = 0; i < measurements.size(); i++) {
                measurementsString += measurements.get(i).getParameter() + ";" + measurements.get(i).getValue() + ";" + measurements.get(i).getUnit();
                if (i != measurements.size() - 1) {
                    measurementsString += "|";
                }
            }
        }
        return measurementsString;
    }
}