package at.fhj.airkoality.db.room;

import android.arch.persistence.room.Dao;
import android.arch.persistence.room.Insert;
import android.arch.persistence.room.OnConflictStrategy;
import android.arch.persistence.room.Query;

import java.util.List;

import at.fhj.airkoality.model.Location;

@Dao
public interface LocationDAO {

    @Query("SELECT * FROM location")
    List<Location> getAll();

    @Query("SELECT * FROM location WHERE location = :locationName")
    Location getLocationWithName(String locationName);


    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void addLocation(Location location);

    @Insert(onConflict = OnConflictStrategy.REPLACE)
    void addAll(List<Location> locations);

    @Query("DELETE FROM location")
    void clear();
}
